var tabloc = {
	lock_onclick : function(evt){
		tabloc.onclick(evt, false);
	},

	shiftlock_onclick : function(evt){
		tabloc.onclick(evt, true);
	},

	onclick : function(evt, fgtab){
		if(evt && evt.target && evt.button == 0){
			var a = evt.target;
			while(a && !a.href && a.tagName && (a.tagName.toLowerCase() != "form")){
				a = a.parentNode;
			}

			if(a && a.href){
				tabloc.href(a, evt, fgtab);
			}else if(a && a.tagName && a.tagName.toLowerCase() === "form"){
				tabloc.form(a, evt);
			}
		}
	},

	href : function(a, evt, fgtab) {
		var exinpage     = true; // tabloc.pref.getBoolPref("extensions.tabloc.ex_inpagelink");
		var exjavascript = true; // tabloc.pref.getBoolPref("extensions.tabloc.ex_javascript");
		var currentURL   = a.ownerDocument.URL;

		if(exinpage){
			var targethref = tabloc.getTargetURL(a).split("#")[0];
			if(a.href === targethref || a.href.indexOf(targethref + "#") == 0){
				return;
			}
		}
		if(exjavascript){
			if(a.href.indexOf("javascript:") == 0){
				return;
			}
		}

		chrome.extension.sendRequest({
			command: "createTab",
			url: a.href,
			selected: fgtab
		});

		evt.stopPropagation();
		evt.preventDefault();
	},

	getTargetURL : function(a) {
		var target = a.target;
		if(target == null || target == "" || target == "_self"){
			return a.ownerDocument.URL;
		}else if(target == "_blank"){
			return "";
		}else if(target == "_top"){
			return gBrowser.currentURI.spec;
		}else{
			var frames = window.frames;
			for(var i=0; i<frames.length; i++){
				if(frames[i].name == target){
					return frames[i].document.location.href;
				}
			}
		}
		return a.ownerDocument.URL;
	},

	form : function(a, evt) {
		var exform = false; // tabloc.pref.getBoolPref("extensions.tabloc.ex_formsubmit");
		if(exform){
			return;
		}
		a.setAttribute("__tabloc_target", a.target);
		a.target = "_blank";
		window.setTimeout(tabloc.restore_target, 500, a);
	},

	restore_target : function(a){
		if(a.hasAttribute("__tabloc_target")){
			a.target = a.getAttribute("__tabloc_target");
			a.removeAttribute("__tabloc_target");
		}
	},
}

chrome.extension.onRequest.addListener(
	function(request, sender, sendResponse) {
		if (request.command == "lockTab") {
			window.addEventListener("click", tabloc.lock_onclick, true);
			sendResponse({result: "ok"});
		}else if (request.command == "unlockTab") {
			window.removeEventListener("click", tabloc.lock_onclick, true);
			sendResponse({result: "ok"});
		}else{
			sendResponse({});
		}
	}
);
