tabloc = {
	locked : {},
	isLocked : function(tabId) {
		return tabloc.locked["locked_" + tabId];
	},
	setLocked : function(tabId, value) {
		if(value){
			tabloc.locked["locked_" + tabId] = value;
		}else{
			delete tabloc.locked["locked_" + tabId];
		}
	}
};

chrome.browserAction.onClicked.addListener(function(tab){
	if(! tabloc.isLocked(tab.id)){
		chrome.tabs.sendRequest(tab.id, {command: "lockTab"}, function(response){
			if(response.result == "ok"){
				tabloc.setLocked(tab.id, true);
				chrome.browserAction.setIcon({
					path: "locked.png",
					tabId: tab.id
				});
			}
		});
	}else{
		chrome.tabs.sendRequest(tab.id, {command: "unlockTab"}, function(response){
			if(response.result == "ok"){
				tabloc.setLocked(tab.id, false);
				chrome.browserAction.setIcon({
					path: "tabloc.png",
					tabId: tab.id
				});
			}
		});
	}
});

chrome.extension.onRequest.addListener(
	function(request, sender, sendResponse) {
		if (request.command == "createTab") {
			chrome.tabs.create({
				url: request.url,
				selected: request.selected
			});
			sendResponse({result: "ok"});
		}else{
			sendResponse({});
		}
	}
);
